import processing.core.*; import processing.pdf.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class _070227_Wachstum extends PApplet {// Globale Variabeln


int Breite = 600;                                    // Breite des Fensters
int Hoehe = 600;                                     // H\u00f6he des Fensters
int AnzSpalten = 2 + 2;                              // Anzahl Spalten des Rasters
int AnzZeilen = 2 + 2;                               // Anzahl Spalten des Rasters
float FeldBreite = Breite / (AnzSpalten-2);          // Breite eines Feldes
float FeldHoehe = Hoehe / (AnzZeilen-2);             // H\u00f6he eines Feldes

int Hintergrund = color (255);                     // Hintergrundfarbe
int FensterColor = color (255);                    // Farbe Fenster
int RahmenColor = FensterColor;                    // Farbe Fenster
int FensterStroke = color (200);                   // Farbe Fensterumriss
int c1wachsen = color (255);                       // Farbe Kreis innen im Wachstum
int c2wachsen = color (200, 160, 80);              // Farbe Kreis Mitte im Wachstum
int c3wachsen = color (150, 120, 50);              // Farbe Kreis aussen im Wachstum
int c1fertig = color (255);                        // Farbe Kreis innen fertige Zelle
int c2fertig = color (180, 180, 80);               // Farbe Kreis Mitte fertige Zelle
int c3fertig = color (130, 130, 50);               // Farbe Kreis aussen fertige Zelle

int AnzahlOeffnungen = 3;                            // Anzahl \u00d6ffnungen total
int minAbstand = 50;                                 // min. Abstand zwischen zwei \u00d6ffnungen
int minB = 50;                                       // min. Fensterbreite
int maxB = 200;                                      // max. Fensterbreite
float Rahmenbreite = 5;                              // Breite Fensterrahmen

int AnzahlZellen = 400;                              // Anzahl Zellen
float Rand = 2;                                      // Rand der \u00e4usseren Kreise
float minR = 2;                                      // minimaler Radius einer Zelle
float minA = 3;                                      // minimaler Abstand, darunter = ber\u00fchrt

int o = 1;                                           // Anzal neue Zellen pro Frame
int m = 5;                                           // Anzal Wachstumsrunden pro Durchgang
float f = 0.05f;                                      // Wachstum pro Durchgang
float g = f*4;                                       // Verschiebung pro Durchgang

int n = 0;                                           // Z\u00e4hler gezeichnete Zelle
int AnzahlFertigeZellen = 0;                         // Z\u00e4hler fertige Zellen
int ZaehlerOeffnungen = 0;                           // Z\u00e4hler gezeichnete \u00d6ffnungen

boolean schlaufen = false;                           // "draw" stoppen/starten \u00fcber Mausklick

Zelle [] meineZelle = new Zelle [AnzahlZellen];
Oeffnung [] meineOeffnung = new Oeffnung [AnzahlOeffnungen];
Feld [] meinFeld = new Feld [AnzSpalten*AnzZeilen];

//----------------------------------------------------------------------------------------------------
// Initialisierung
//----------------------------------------------------------------------------------------------------



public void setup()
{
  size (Breite, Hoehe);
  // frameRate (5);
  background (Hintergrund);

  for (int s = 0; s < AnzSpalten; s++) {                 // Felder generieren
    for (int z = 0; z < AnzZeilen; z++){
      meinFeld [z*AnzSpalten + s] = new Feld (s, z);                         
    }
  }
  
  for (int i=0; i < AnzahlOeffnungen; i++) {             // Oeffnungen generieren und zeichnen
    meineOeffnung [i] = new Oeffnung ();
    ZaehlerOeffnungen++;
    meineOeffnung [i].zeichnen ();
  }

  meineZelle [0] = new Zelle ();                         // erste Zelle generieren und zeichnen
  meineZelle [0].zeichnen ();
  
  noLoop ();
  
}

//----------------------------------------------------------------------------------------------------
// Frame f\u00fcr Frame wiederholt
//----------------------------------------------------------------------------------------------------

public void draw ()
{
  println (n);
  
  for (int j = 1; j <= m; j++)                // m-mal wachsen, bevor eine neue Zelle generiert wird
  {
    for (int i = 0; i <= n; i++)             // alle bestehenden Zellen "durchschlaufen"
    {
      meineZelle [i].entwickeln ();    
    }
  }

  if (n < AnzahlZellen-o-1)                // schlaufen, falls Anzahl Zellen noch nicht erreicht ist
  {
    for (int i = 0; i < o; i++) {          // o neue Zellen pro Frame
      n++;
      meineZelle [n] = new Zelle ();         // neue Zelle generieren
      meineZelle [n].zeichnen ();            // generierte Zelle zeichnen
    }
  } 
}

// Funktionen


//----------------------------------------------------------------------------------------------------
// starten / stoppen per Mausklick

public void mouseClicked()
{
  if (schlaufen == true) {
    noLoop ();
    schlaufen = false;
  } else if (schlaufen == false) {
    loop ();
    schlaufen = true;
  }
}

//----------------------------------------------------------------------------------------------------
// "n"-Taste gedr\u00fcckt: initialisiert das Programm neu  (l\u00e4dt neue "Zufallsfassade")
// "p"-Taste gedr\u00fcckt: schreibt pdf-File des aktuellen Frames

public void keyPressed()
{
  if (key == 'n' || key == 'N') {
    background (Hintergrund);
    n = 0;                                           // n zur\u00fccksetzen
    ZaehlerOeffnungen = 0;                           // \u00d6ffnungsz\u00e4hler zur\u00fccksetzen
    AnzahlFertigeZellen = 0;                         // Z\u00e4hler zur\u00fccksetzen
    for (int s = 0; s < AnzSpalten; s++) {           // Felder generieren
      for (int z = 0; z < AnzZeilen; z++){
        meinFeld [z*AnzSpalten + s] = new Feld (s, z);                         
      }
    }
    for (int i=0; i < AnzahlOeffnungen; i++) {       // Oeffnungen neu generieren und zeichnen
      meineOeffnung [i] = new Oeffnung ();
      ZaehlerOeffnungen++;
      meineOeffnung [i].zeichnen ();
    }
    meineZelle [n] = new Zelle ();                   // erste Zelle generieren
    meineZelle [n].zeichnen ();
    loop ();
  }
  
  if (key == 'p' || key == 'P') {
    pdfSchreiben();
  }
}

//----------------------------------------------------------------------------------------------------
// schreibt pdf-File des aktuellen Frames

public void pdfSchreiben()
{
  println ("pdf schreiben");
  beginRecord (PDF, "frame-####.pdf");
  fill (Hintergrund);                             // Hintergrund zeichnen
  noStroke ();
  rectMode(CORNERS);
  rect (0, 0, width, height);
  for (int i=0; i<=n; i++) {                      // Zellen zeichnen
    meineZelle [i].zeichnen ();
  }
  for (int i=0; i < AnzahlOeffnungen; i++) {      // Oeffnungen zeichnen
    meineOeffnung [i].zeichnen ();
  }
  endRecord();
  println ("pdf geschrieben");
}

//----------------------------------------------------------------------------------------------------
// zeichnet einen Kreis in einen anderen, Eingabe: Mittelpunkt und Radius des umfassenden Kreises, 
// Richtung  des Ber\u00fchrungspunktes, Radius und Farbe des inneren Kreises
// Ausgabe: Koordinaten des Mittelpunktes des inneren Kreises als Array

public float [] zeichne_KreisInKreis (float xUmfassung, float yUmfassung, float rUmfassung, float xKreis, 
                               float yKreis, float rKreis, int fKreis)    
{
  float [] Zentrum = new float [2];
  Zentrum [0] = xUmfassung + (rUmfassung / rKreis)*xKreis - xKreis;     // Koordinaten des Mittel-
  Zentrum [1] = yUmfassung + (rUmfassung / rKreis)*yKreis - yKreis;     // punktes des inneren Kreises
  
  if (rKreis > Rand) {
    zeichne_Kreis (Zentrum [0], Zentrum [1], rKreis - Rand, fKreis);
  }
  return Zentrum;
}  

//----------------------------------------------------------------------------------------------------
// zeichnet einen Kreis mit einer bestimmten Farbe

public void zeichne_Kreis (float xKreis, float yKreis, float rKreis, int fKreis)
{
  ellipseMode (CENTER_RADIUS);
  noStroke ();
  fill (fKreis);
  ellipse (xKreis, yKreis, rKreis, rKreis);
}  

//----------------------------------------------------------------------------------------------------

class Feld
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  int FeldSpalte, FeldZeile;          // Spalten- bzw Zeilennummer des Feldes
  int FeldIndex;                      // Feldnummer
  
  // das Array "beeinflussendeZelle" enth\u00e4lt die Indizes der Zellen mit Mittelpunkt im Feld selber 
  // oder in einem der acht benachbarten Feldern (dient der effizienteren Ber\u00fchrungsabfrage)
  int [] beeinflussendeZelle = new int [AnzahlZellen]; 
  
  int AnzEinflusszellen;              // Anzahl eingeschriebene Zellen im Array

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Feld (int s, int z)                 // Parameter: Zeilen und Spaltennummer
  {
    FeldSpalte = s;
    FeldZeile = z;
    FeldIndex = FeldZeile * AnzSpalten + FeldSpalte;
    AnzEinflusszellen = 0;
  }

  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------
  
  // schreibt den \u00fcbergebenen Index in die n\u00e4chste freie Stelle des Arrays

  public void ZelleEinschreiben (int ZelleIndex)
  {
    beeinflussendeZelle [AnzEinflusszellen] = ZelleIndex;
    AnzEinflusszellen++;
  }

  //--------------------------------------------------------------------------------------------------
  // gibt die Anzahl Zellen im Array zur\u00fcck

  public int getAnzEinflusszellen ()
  {
    return AnzEinflusszellen;
  }

  //--------------------------------------------------------------------------------------------------  
  // gibt den Index der Zelle an der abgefragten Stelle im Array zur\u00fcck
  public int getBeeinflussendeZelle (int ArrayIndex)
  {
    return beeinflussendeZelle [ArrayIndex];
  }

  //--------------------------------------------------------------------------------------------------  

}

class Oeffnung
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  float x1;                // x-Wert links
  float x2;                // x-Wert rechts
  float y1;                // y-Wert oben
  float y2;                // y-Wert unten

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Oeffnung (float l, float r, float o, float u)      // Generierung mit Koordinaten
  {
    x1 = l;
    x2 = r;
    y1 = o;
    y2 = u;
  }
  
  Oeffnung ()                                        // Generierung zuf\u00e4llig
  {
    boolean gefunden = false;
    
    while (gefunden == false)
    {
      x1 = random (0, width);
      y1 = random (0, width);
      x2 = x1 + random (minB, maxB);
      y2 = y1 + random (minB, maxB);
    
      gefunden = testen ();
    }
  }

  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------

  // zeichnet \u00d6ffnung und Rahmen
  
  public void zeichnen ()
  {
    fill (RahmenColor);                              // Fensterrahmen
    stroke(FensterStroke);
    strokeWeight(0.2f);
    rectMode(CORNERS);
    rect (x1, y1, x2, y2);
    
    fill (FensterColor);                             // Fenster
    stroke(FensterStroke);
    strokeWeight(0.2f);
    rectMode(CORNERS);
    rect (x1 + Rahmenbreite, y1 + Rahmenbreite, x2 - Rahmenbreite, y2 - Rahmenbreite);
    
  }

  //-------------------------------------------------------------------------------------------------- 
  // \u00fcberschneidet sich die \u00d6ffnung mit einer anderen? (f\u00fcr die Generierung der \u00d6ffnungen)

  public boolean testen ()
  {
    boolean ok = true;
    
    // R\u00e4nder
    
    if ( (x1 > minAbstand && x2 < width - minAbstand 
          && y1 > minAbstand && y2 < height - minAbstand) == false ) 
    {
      ok = false;
    }
    
    // andere \u00d6ffnungen
    
    if (ZaehlerOeffnungen != 0) {
      for (int i = 0; i < ZaehlerOeffnungen; i++)
      {
        float L = meineOeffnung [i].getGeometrie () [0];
        float R = meineOeffnung [i].getGeometrie () [1];
        float O = meineOeffnung [i].getGeometrie () [2];
        float U = meineOeffnung [i].getGeometrie () [3];
      
        if ( (x1 > R + minAbstand  || x2 < L - minAbstand 
             || y1 > U + minAbstand || y2 < O - minAbstand) == false )
        {
          ok = false;
        }
      }
    }
    
    return ok; 
  }

  //--------------------------------------------------------------------------------------------------
  // gibt "Koordinaten" (links, rechts, oben, unten) der \u00d6ffnung in einem Array zur\u00fcck

  public float [] getGeometrie ()
  {
    float [] Geometrie = {x1, x2, y1, y2};
    return Geometrie;
  }  
  
  //--------------------------------------------------------------------------------------------------

}

class Zelle
{

  //--------------------------------------------------------------------------------------------------
  // Variabeln
  //--------------------------------------------------------------------------------------------------

  int ZelleIndex;                   // Position im Zellen-Array
  
  float xZelle, yZelle;             // Koordinaten des Mittelpunktes der Zelle
  float rZelle;                     // Radius der Zelle

  // zur effizienten Ber\u00fchrungsz\u00e4hlung wird die Fl\u00e4che in verschiedene Felder aufgeteilt:
  int Spalte, Zeile;                // Spalten-/ bzw. Zeilennnummer im Raster
  int FeldIndex;                    // Feldnummer (Numerierung Zeile f\u00fcr Zeile, oben links = 0)
  
  int cInnen = c1wachsen;         // Farbe Kreis innen
  int cMitte = c2wachsen;         // Farbe Kreis Mitte
  int cAussen = c3wachsen;        // Farbe Kreis aussen
  
  boolean fertig;                   // Zellen, die mind. 3 andere ber\u00fchren sind "ausgewachsen"
  
  // Variabeln f\u00fcr das Wachsen/Bewegen der Zellen (wird bei jedem Durchgang neu gesetzt)
  int Beruehrungszaehler = 0;                       // wird bei jedem Durchgang von Neuem hochgez\u00e4hlt        
  float [] Beruehrungspunkt = new float [4];        // Koordinaten 1. und 2. Ber\u00fchrungspunkt
  
  // Variabeln zum Zeichnen der verschachtelten Kreise (bleiben nach der ersten Ber\u00fchrung unver\u00e4ndert)
  int AnzahlBeruehrungen = 0;        // effektive Anzahl Ber\u00fchrungen
  float xB1, yB1;                    // Koordinaten bei der 1. Ber\u00fchrung (rel. zum Zellenmittelpunkt)
  float r1;                          // Radius bei der 1. Ber\u00fchrung
  float xB2, yB2;                    // Koordinaten bei der 2. Ber\u00fchrung (rel. zum Zellenmittelpunkt)
  float r2;                          // Radius bei der 2. Ber\u00fchrung
  float [] z1 = new float [2];       // Koordinaten des Mittelpunkts des 1. Ber\u00fchrungskreises  
  float [] z2 = new float [2];       // Koordinaten des Mittelpunkts des 2. Ber\u00fchrungskreises
  

  //--------------------------------------------------------------------------------------------------
  // Konstruktoren
  //--------------------------------------------------------------------------------------------------

  Zelle ()                           // Generierung an einer unbelegten Zufallsposition                
  {
    starten ();
  }


  //--------------------------------------------------------------------------------------------------
  // Methoden
  //--------------------------------------------------------------------------------------------------
  
  // l\u00e4sst die Zellen wachsen und verschiebt sie gegebenenfalls (der Anzahl Ber\u00fchrungen entsprechend)
  
  public void entwickeln ()
  {
    if (getFertig () == false)                        // falls die Zelle noch nicht fertig ist
    {
      int Beruehrungen = BeruehrungenZaehlen ();      // Zelle testen
        
      switch (Beruehrungen) {
          
        case 0:                                       // keine Ber\u00fchrung -> wachsen
          wachsen();
          break;
            
        case 1:                                       // 1 Ber\u00fchrung -> bewegen, wachsen
          loeschen();
          bewegen_Ber_1();
          wachsen();
          break;
            
        case 2:                                       // 2 Ber\u00fchrung -> bewegen, wachsen
          loeschen();
          bewegen_Ber_2();
          wachsen();
          break;
            
        default:                                      // 3 oder mehr Ber\u00fchrungen
          if (getGeometrie () [2] < minR) {           // zu kleine Zellen werden neu gestartet
            loeschen ();
            starten ();          
          } else {                                    // grosse Zellen werden "fertig" gesetzt
            setFertig (true);
            zeichnen ();
          }
          break;  
      }
    }
  }

  //--------------------------------------------------------------------------------------------------
  // zeichnet die Zellen (unterschiedlich, je nach Anzahl Ber\u00fchrungen)
  
  public void zeichnen ()                                      
  {
    switch (AnzahlBeruehrungen)
    {
    case 0:                                              // keine Ber\u00fchrung
      zeichne_Kreis (xZelle, yZelle, rZelle, cMitte);
      if (rZelle > Rand)
      {
        zeichne_Kreis (xZelle, yZelle, rZelle-Rand, cInnen);
      }
      break;

    case 1:                                              // 1 Ber\u00fchrung
      zeichne_Kreis (xZelle, yZelle, rZelle, cMitte);
      z1 = zeichne_KreisInKreis (xZelle, yZelle, rZelle, xB1, yB1, r1, cInnen);
      break;

    default:                                              // 2 oder mehr Ber\u00fchrungen
      zeichne_Kreis (xZelle, yZelle, rZelle, cAussen);
      z2 = zeichne_KreisInKreis (xZelle, yZelle, rZelle, xB2, yB2, r2, cMitte);
      z1 = zeichne_KreisInKreis (z2 [0], z2 [1], r2, xB1, yB1, r1, cInnen);
      break;
    }
  }  

  //--------------------------------------------------------------------------------------------------
  // l\u00f6scht (bzw. \u00fcberzeichnet) die Zelle (f\u00fcr die Bildschirmdarstellung)
  
  public void loeschen ()
  {
    zeichne_Kreis (xZelle, yZelle, rZelle, Hintergrund);
  }

  //--------------------------------------------------------------------------------------------------
  // wachsen: vergr\u00f6ssern des Radius und neu zeichnen

  public void wachsen ()
  {
    rZelle += f;
    zeichnen ();
  }

  //--------------------------------------------------------------------------------------------------
  // gibt die Anzahl Ber\u00fchrungen der Zelle zur\u00fcck und schreibt die Koordinaten der Ber\u00fchrungspunkte
  // ins Beruehrungspunkt-Array (mit der Methode SetBerKoor ())

  public int BeruehrungenZaehlen ()
  {
    Beruehrungszaehler = 0;

    // Zellen (sucht Ber\u00fchrungen mit anderen Zellen im entsprechenden Feld)

    int AnzEinflussZ = meinFeld [FeldIndex].getAnzEinflusszellen ();
    for (int i=0; i < AnzEinflussZ; i++) {
      int IndexNachbarzelle = meinFeld [FeldIndex].getBeeinflussendeZelle (i);
      float xNachbar = meineZelle [IndexNachbarzelle].getGeometrie () [0];
      float yNachbar = meineZelle [IndexNachbarzelle].getGeometrie () [1];
      float rNachbar = meineZelle [IndexNachbarzelle].getGeometrie () [2];
      float Abstand = sqrt(sq(xNachbar - xZelle) + sq(yNachbar -yZelle));

      if (Abstand <= rZelle + minA + rNachbar && Abstand != 0) {       // bei Ber\u00fchrung: SetBerKoor ()
        setBerKoor (xZelle + (rZelle/Abstand)*(xNachbar - xZelle), 
                    yZelle + (rZelle/Abstand)*(yNachbar - yZelle));
      }
    }

    // \u00d6ffnungen (sucht Ber\u00fchrungen mit \u00d6ffnungen)

    for (int i=0; i < AnzahlOeffnungen; i++)
    {
      float xL = meineOeffnung [i].getGeometrie () [0];
      float xR = meineOeffnung [i].getGeometrie () [1];
      float yO = meineOeffnung [i].getGeometrie () [2];
      float yU = meineOeffnung [i].getGeometrie () [3];

      if (yZelle <= yU + rZelle + minA && yZelle >= yO - rZelle -minA        // nur schlaufen, falls
          && xZelle <= xR + rZelle + minA && xZelle >= xL - rZelle - minA)   // Ber\u00fchrung m\u00f6glich
      {
        if (yZelle < yU && yZelle > yO && xZelle < xR && xZelle > xL) {      // Mittelpunkt liegt 
          setBerKoor (99, 99);                                               // innerhalb der \u00d6ffnung
          
        } else if (yZelle <= yU && yZelle >= yO) {      // Ber\u00fchrung links oder rechts
            if (xZelle < xL) {                          // Ber\u00fchrung links
              setBerKoor (xZelle + rZelle, yZelle);
            } else if (xZelle > xR) {                   // Ber\u00fchrung rechts
            setBerKoor (xZelle - rZelle, yZelle);
          }
        } 
        else if (xZelle <= xR && xZelle >= xL) {        // Ber\u00fchrung oben oder unten
          if (yZelle < yO) {                            // Ber\u00fchrung oben
            setBerKoor (xZelle, yZelle + rZelle);
          } else if (yZelle > yU) {                     // Ber\u00fchrung rechts
            setBerKoor (xZelle, yZelle - rZelle);
          }
        } else {                                        // Ber\u00fchrung an einer Ecke
          if (sqrt(sq(xL - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {         // Ber. unten links
            float Abstand = sqrt(sq(xL - xZelle) + sq(yU -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xL - xZelle), 
                        yZelle + (rZelle/Abstand)*(yU - yZelle));
          } else if (sqrt(sq(xR - xZelle) + sq(yU -yZelle)) <= rZelle + minA) {  // Ber. unten rechts
            float Abstand = sqrt(sq(xR - xZelle) + sq(yU -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xR - xZelle), 
                        yZelle + (rZelle/Abstand)*(yU - yZelle));
          } else if (sqrt(sq(xR - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {  // Ber. oben rechts
            float Abstand = sqrt(sq(xR - xZelle) + sq(yO -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xR - xZelle), 
                        yZelle + (rZelle/Abstand)*(yO - yZelle));
          } else if (sqrt(sq(xL - xZelle) + sq(yO -yZelle)) <= rZelle + minA) {  // Ber. oben links
            float Abstand = sqrt(sq(xL - xZelle) + sq(yO -yZelle));
            setBerKoor (xZelle + (rZelle/Abstand)*(xL - xZelle), 
                        yZelle + (rZelle/Abstand)*(yO - yZelle));
          }
        }
      }
    }

    // R\u00e4nder (sucht Ber\u00fchrungen mit den R\u00e4ndern)

    if (xZelle <= rZelle + minA) {                     // Ber\u00fchrung links
      setBerKoor (xZelle - rZelle, yZelle);
    } if (xZelle >= width - rZelle - minA) {           // Ber\u00fchrung rechts
      setBerKoor (xZelle + rZelle, yZelle);
    } if (yZelle <= rZelle + minA) {                   // Ber\u00fchrung oben
      setBerKoor (xZelle, yZelle - rZelle);
    } if (yZelle >= height - rZelle - minA) {          // Ber\u00fchrung unten
      setBerKoor (xZelle, yZelle + rZelle);
    }
    
    // bei der jeweils ersten zus\u00e4tzlichen Ber\u00fchrung wird setBeruehrungspunkt () aufgerufen 
    
    if (Beruehrungszaehler > AnzahlBeruehrungen) { 
      setBeruehrungspunkt (Beruehrungszaehler);
    }
    
    return (Beruehrungszaehler);
  }

  //--------------------------------------------------------------------------------------------------
  // bewegt die Zelle bei nur einer Ber\u00fchrung vom Ber\u00fchrungspunkt weg
  
  public void bewegen_Ber_1 ()
  {
    xZelle += g*(xZelle - Beruehrungspunkt [0])/rZelle;        // Mittelpunkt verschieben
    yZelle += g*(yZelle - Beruehrungspunkt [1])/rZelle;
  }

  //--------------------------------------------------------------------------------------------------
  // bewegt die Zelle bei zwei Ber\u00fchrung von den Ber\u00fchrungspunkten weg

  public void bewegen_Ber_2 ()
  {
    float xMitte = (Beruehrungspunkt [0] + Beruehrungspunkt [2])/2;
    float yMitte = (Beruehrungspunkt [1] + Beruehrungspunkt [3])/2;
    float AbstandMitte = sqrt(sq(xMitte - xZelle) + sq(yMitte - yZelle));
    // float CosinusWinkel = AbstandMitte / rZelle;
    if (AbstandMitte > 0.2f) {                                  // Rundungsungenauigkeiten vermeiden
      xZelle += g*((xZelle - xMitte)/AbstandMitte);             // Mittelpunkt verschieben
      yZelle += g*((yZelle - yMitte)/AbstandMitte);
    } else {                                                    // zwischen 2 anderen eingeklemmte
      setFertig (true);                                         // Zelle = fertig
    }                                                                
  }

  //--------------------------------------------------------------------------------------------------
  // schreibt den Index der Zelle in das eigene (Spalte, Zeile) und in die 8 angrenzenden Felder

  public void EinflussEinschreiben ()
  {
    int FeldZaehler;
    for (int s = Spalte - 1; s <= Spalte + 1; s++) {
      for (int z = Zeile - 1; z <= Zeile + 1; z++) {
        FeldZaehler = z * AnzSpalten + s;
        meinFeld [FeldZaehler].ZelleEinschreiben (ZelleIndex);
      }
    }
  }

  //--------------------------------------------------------------------------------------------------
  // erh\u00f6ht den Ber\u00fchrungsz\u00e4hler und schreibt die Koordinaten des Ber\u00fchrungspunktes ins Array

  public void setBerKoor (float x, float y)                    
  {
    Beruehrungszaehler++;
    if (Beruehrungszaehler<=2) {
      Beruehrungspunkt [Beruehrungszaehler*2-2] = x;        // x-Wert Ber\u00fchrunspunkt
      Beruehrungspunkt [Beruehrungszaehler*2-1] = y;        // y-Wert Ber\u00fchrunspunkt
    }
  }

  //--------------------------------------------------------------------------------------------------
  // schreibt beim jeweils ersten Ansteigen des Ber\u00fchrungsz\u00e4hlers Koordinaten und Radius in die 
  // entsprechenden Variabeln

  public void setBeruehrungspunkt (int BerZaehl)
  {
    AnzahlBeruehrungen = BerZaehl;
    
    if (xB1 == -99) {                             // erster Ber\u00fchrungspunkt wurde noch nicht gesetzt
      r1 = rZelle;
      xB1 = Beruehrungspunkt [0] - xZelle;
      yB1 = Beruehrungspunkt [1] - yZelle;
    }
    if (AnzahlBeruehrungen > 1 && xB2 == -99) {   // zweiter Ber\u00fchrungspunkt wurde noch nicht gesetzt
      r2 = rZelle;
      xB2 = Beruehrungspunkt [2] - xZelle;
      yB2 = Beruehrungspunkt [3] - yZelle;
    }
  }    

  //--------------------------------------------------------------------------------------------------
  // sucht eine freie Position und setzt die Variabeln zur\u00fcck
  
  public void starten ()
  {
    int Ber = 99;
    
    while (Ber != 0)                               // freie Position Suchen
    {
      xZelle = random (width);            
      yZelle = random (height);
      rZelle = 0;
      Spalte = (int) (xZelle / FeldBreite) + 1;
      Zeile = (int) (yZelle / FeldHoehe) + 1;
      FeldIndex = Zeile * AnzSpalten + Spalte;
      Ber = BeruehrungenZaehlen ();
    }

    ZelleIndex = n;
    cInnen = c1wachsen;                            // alle Variabeln zur\u00fccksetzen
    cMitte = c2wachsen;
    cAussen = c3wachsen;
    fertig = false;
    AnzahlBeruehrungen = 0;
    Beruehrungspunkt = new float [4];
    xB1 = -99;
    yB1 = -99;  
    xB2 = -99;
    yB2 = -99;
    EinflussEinschreiben ();                       // Zellenindex in Enflussarray schreiben
  }

  //--------------------------------------------------------------------------------------------------
  // gibt die Koordinaten des Mittelpunktes gefolgt vom Radius in einem Array aus

  public float [] getGeometrie ()
  {
    float [] Geometrie = {
      xZelle, yZelle, rZelle    };
    return Geometrie;
  }  

  //--------------------------------------------------------------------------------------------------
  // setzt die Zelle "fertig", setzt deren Farben neu und erh\u00f6ht den Z\u00e4hler "AnzahlFertigeZellen"

  public void setFertig (boolean f) 
  {
    fertig = f;
    cInnen = c1fertig;
    cMitte = c2fertig;
    cAussen = c3fertig; 
    AnzahlFertigeZellen++;
    println ("fertige Zellen: " + AnzahlFertigeZellen);
    if (AnzahlFertigeZellen == AnzahlZellen) {
      noLoop ();
    }
  }    

  // --------------------------------------------------------------------------------------------------
  // liest die Variable "fertig" aus

  public boolean getFertig ()                                // Variable "fertig" auslesen     
  {
    return fertig;
  }  

  //--------------------------------------------------------------------------------------------------  

}
static public void main(String args[]) {   PApplet.main(new String[] { "_070227_Wachstum" });}}